// SAX.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "SaxContentHandlerImp.h"


int _tmain(int argc, _TCHAR* argv[])
{
	if (argc < 2)
		return 0;


	TCHAR* pPath = argv[1];


	CoInitialize(NULL); 


	ISAXXMLReader* pRdr = NULL;

	HRESULT hr = CoCreateInstance(
					__uuidof(SAXXMLReader), 
					NULL, 
					CLSCTX_ALL, 
					__uuidof(ISAXXMLReader), 
					(void **)&pRdr);

	if (!FAILED(hr)) 
	{
		ISAXContentHandler* pContentHandler = new CSaxContentHandlerImp;
		hr = pRdr->putContentHandler(pContentHandler);

		//SAXErrorHandlerImpl * pEc = new SAXErrorHandlerImpl();
		//hr = pRdr->putErrorHandler(pEc);

		// SAXDTDHandlerImpl * pDc = new SAXDTDHandlerImpl();
		// hr = pRdr->putDTDHandler(pDc);

		if (FAILED((hr = pRdr->parseURL((unsigned short*)pPath))))
			wprintf(L"\nError parsing file, code: %08X\n\n", hr);
		else
			wprintf(L"\n\nSucess\n\n");

		pRdr->Release();
		delete pContentHandler;

	}
	else
	{
		wprintf(L"\nError creating COM object, code: %08X\n\n", hr);
	}


	CoUninitialize();


	return 0;
}

