#include "StdAfx.h"
#include "SaxContentHandlerImp.h"

CSaxContentHandlerImp::CSaxContentHandlerImp(void)
{
}

CSaxContentHandlerImp::~CSaxContentHandlerImp(void)
{
}

HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::putDocumentLocator( 
			/* [in] */ ISAXLocator __RPC_FAR *pLocator)
{
	return S_OK;
}
		
HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::startDocument()
{
	return S_OK;
}
		
 
HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::endDocument(void)
{
	return S_OK;
}  

HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::startPrefixMapping( 
			/* [in] */ unsigned short __RPC_FAR *pwchPrefix,
			/* [in] */ int cchPrefix,
			/* [in] */ unsigned short __RPC_FAR *pwchUri,
			/* [in] */ int cchUri)
{
	return S_OK;
}


HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::endPrefixMapping( 
			/* [in] */ unsigned short __RPC_FAR *pwchPrefix,
			/* [in] */ int cchPrefix)
{
	return S_OK;
}
		

		
HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::startElement( 
			/* [in] */ unsigned short __RPC_FAR *pwchNamespaceUri,
			/* [in] */ int cchNamespaceUri,
			/* [in] */ unsigned short __RPC_FAR *pwchLocalName,
			/* [in] */ int cchLocalName,
			/* [in] */ unsigned short __RPC_FAR *pwchRawName,
			/* [in] */ int cchRawName,
			/* [in] */ ISAXAttributes __RPC_FAR *pAttributes)
{
	int nAttrCount = 0;
	pAttributes->getLength(&nAttrCount);


	unsigned short *pAttr = NULL, *pValue = NULL;
	int nAttrLen = 0, nValueLen = 0;


	wprintf(L"Local Name: %s\n", pwchLocalName);


	wstring str;

	for (int i = 0; i < nAttrCount; ++i)
	{
		pAttributes->getLocalName(i, &pAttr, &nAttrLen);
		str.assign((wchar_t*)pAttr, nAttrLen);
		wprintf(L"Attribute Name: %s\n", str.c_str());

		pAttributes->getValue(i, &pValue, &nValueLen);
		str.assign((wchar_t*)pValue, nValueLen);
		wprintf(L"Attribute Value: %s\n", str.c_str());
	}


	return S_OK;
}
		
	   
HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::endElement( 
			/* [in] */ unsigned short __RPC_FAR *pwchNamespaceUri,
			/* [in] */ int cchNamespaceUri,
			/* [in] */ unsigned short __RPC_FAR *pwchLocalName,
			/* [in] */ int cchLocalName,
			/* [in] */ unsigned short __RPC_FAR *pwchRawName,
			/* [in] */ int cchRawName)
{

	return S_OK;
}

HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::characters( 
			/* [in] */ unsigned short __RPC_FAR *pwchChars,
			/* [in] */ int cchChars)
{
	if (cchChars > 1)
	{
		wstring str;
		str.assign((wchar_t*)pwchChars, cchChars);

		bool bTrimmed = false;
		for (unsigned i = 0; i < str.length(); ++i) //trim
		{
			if (pwchChars[i] != ' ' && pwchChars[i] != '\t')
			{
				str.erase(0, i);
				bTrimmed = true;
				break;
			}
		}

		if (!str.empty() && bTrimmed)
			wprintf(L"Chars: %s\n", str.c_str());
	}

	return S_OK;
}
		

HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::ignorableWhitespace( 
			/* [in] */ unsigned short __RPC_FAR *pwchChars,
			/* [in] */ int cchChars)
{
	return S_OK;
}
		

HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::processingInstruction( 
			/* [in] */ unsigned short __RPC_FAR *pwchTarget,
			/* [in] */ int cchTarget,
			/* [in] */ unsigned short __RPC_FAR *pwchData,
			/* [in] */ int cchData)
{
	return S_OK;
}
		
		
HRESULT STDMETHODCALLTYPE CSaxContentHandlerImp::skippedEntity( 
			/* [in] */ unsigned short __RPC_FAR *pwchVal,
			/* [in] */ int cchVal)
{
	return S_OK;
}


long __stdcall CSaxContentHandlerImp::QueryInterface(const struct _GUID &riid,void ** ppvObject)
{
	return 0;
}

unsigned long __stdcall CSaxContentHandlerImp::AddRef()
{
	return 0;
}

unsigned long __stdcall CSaxContentHandlerImp::Release()
{
	return 0;
}


